//+------------------------------------------------------------------+
//|                                                      Awesome.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  Green
#property  indicator_color3  Red
extern string symbol="EURUSD";
extern int Period_1=5;
extern int Period_2=34;
extern bool Alerts=true; 
//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  if(symbol=="") symbol=Symbol();
  ObjectsDeleteAll(WindowFind("AO_"+symbol));
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("AO_"+symbol);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   
   string text;
   text=symbol+" NONE";
   if((iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,0)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,0))>
      (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1))) 
     text=symbol+" UP";
   if((iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,0)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,0))<
      (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1)))  
     text=symbol+" DOWN";

     
     //   Text
    if(ObjectFind("text_object"+symbol)==-1) {
     ObjectsDeleteAll(WindowFind("AO_"+symbol));
     ObjectCreate("text_object"+symbol, OBJ_TEXT, WindowFind("AO_"+symbol), iTime(NULL, 0, 20) , 0);
     ObjectSetText("text_object"+symbol, text, 15, "Times New Roman", Gold);
     if(Alerts) {
       if(((iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,0)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,0))>
          (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1)))
          &&(iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1))<
          (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,2)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,2)))
         Alert(symbol," ",Period(),": DOWN -> UP"); 
       
     if(((iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,0)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,0))<
         (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1)))
          &&(iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,1))>
          (iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,2)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,2)))
         Alert(symbol," ",Period(),": UP -> DOWN");            
     }
        
    } else {
     if(ObjectGet("text_object"+symbol, OBJPROP_TIME1)!=iTime(NULL, 0, 20)
     ||ObjectGet("text_object"+symbol, OBJPROP_PRICE1)!=0
     ||ObjectDescription("text_object"+symbol)!=text) 
       ObjectDelete("text_object"+symbol);
    }

   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(symbol,0,Period_1,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(symbol,0,Period_2,0,MODE_SMA,PRICE_MEDIAN,i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

